<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/QualifiedName.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/QualifiedName.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/QualifiedName.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2008 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedName.html">QualifiedName</a>(tuple):</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">    sep = <span class="py-string">''</span></span>
<a id="line11"></a><span class="lineno">11</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedName.html#__getitem__">__getitem__</a>(self, i):</span>
<a id="line13"></a><span class="lineno">13</span><span class="line">        <span class="py-string">&quot;&quot;&quot;If i is a slice, make sure a QualifiedName is returned.&quot;&quot;&quot;</span></span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">        result = super(QualifiedName, self).__getitem__(i)</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">        <span class="py-keyword">if</span> type(i) <span class="py-keyword">is</span> slice:</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">            <span class="py-comment"># Wrap the result</span></span>
<a id="line18"></a><span class="lineno">18</span><span class="line">            <span class="py-keyword">return</span> type(self)(result)</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">            <span class="py-keyword">return</span> result</span>
<a id="line21"></a><span class="lineno">21</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedName.html#__getslice__">__getslice__</a>(self, begin, end):</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        <span class="py-string">&quot;&quot;&quot;This method exists because python &lt; 3.0 still uses __getslice__</span></span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="py-string">        for builtin types. (See http://bugs.python.org/issue2041)&quot;&quot;&quot;</span></span>
<a id="line25"></a><span class="lineno">25</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">        <span class="py-keyword">return</span> self.__getitem__(slice(begin, end, None))</span>
<a id="line27"></a><span class="lineno">27</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedName.html#__add__">__add__</a>(self, other):</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Overload self + other to preserve the type.&quot;&quot;&quot;</span></span>
<a id="line30"></a><span class="lineno">30</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">        <span class="py-keyword">return</span> type(self)(tuple(self) + other)</span>
<a id="line32"></a><span class="lineno">32</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedName.html#prune">prune</a>(self, other):</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return a copy of other with any prefix it shares with self removed.</span></span>
<a id="line35"></a><span class="lineno">35</span><span class="line"><span class="py-string">   </span></span>
<a id="line36"></a><span class="lineno">36</span><span class="line"><span class="py-string">        e.g. ('A', 'B', 'C', 'D').prune(('A', 'B', 'D')) -&gt; ('C', 'D')&quot;&quot;&quot;</span></span>
<a id="line37"></a><span class="lineno">37</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        target = list(other)</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">        i = 0</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        <span class="py-keyword">while</span> (len(target) &gt; 1 <span class="py-keyword">and</span> i &lt; len(self) <span class="py-keyword">and</span> target[0] == self[i]):</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">            <span class="py-keyword">del</span> target[0]</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">            i += 1</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">        <span class="py-keyword">return</span> type(other)(target)</span>
<a id="line44"></a><span class="lineno">44</span>
<a id="line45"></a><span class="lineno">45</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedCxxName.html">QualifiedCxxName</a>(QualifiedName):</span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">    sep = <span class="py-string">'::'</span></span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedCxxName.html#__str__">__str__</a>(self):</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'::'</span>.join(self)</span>
<a id="line51"></a><span class="lineno">51</span>
<a id="line52"></a><span class="lineno">52</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedPythonName.html">QualifiedPythonName</a>(QualifiedName):</span>
<a id="line53"></a><span class="lineno">53</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">    sep = <span class="py-string">'.'</span></span>
<a id="line55"></a><span class="lineno">55</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/QualifiedName/QualifiedPythonName.html#__str__">__str__</a>(self):</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'.'</span>.join(self)</span>
<a id="line58"></a><span class="lineno">58</span>
<a id="line59"></a><span class="lineno">59</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
